#include "/musr/H/ugens.h"
#include "/musr/H/sfheader.h"
#include "/musr/macros/macros.h"
#import <objc/objc.h>
#import "/musr/objc/Comb.h"
#import "/musr/objc/Allpass.h"
#define MAXCOMBS 16
struct combdata {
	float loopt;
	float rvt;
	} comblist[MAXCOMBS];
struct allpassdata {
	float loopt;
	float rvt;
	} allpasslist[MAXCOMBS];
int nAllpasses = 0;
int nCombs=0;

extern SFHEADER sfdesc[NFILES];

double reverbit(p,n_args)
float *p;
{
	int nchans,nsamps,input,output,i,j;
	float out[4],xin[4],sig;
	id myComb[MAXCOMBS],myAllpass[MAXCOMBS];
	/* start,dur,inskip,rvt,lpt1,lpt2....lptn */

	input=0; output=1;
	nchans = sfchans(&sfdesc[0]);
	nsamps=setnote(p[0],p[1],output);
	setnote(p[2],p[1],input);
	i=0;
	for(i=0; i<nCombs; i++) {
		myComb[i] = [Comb create];
		[myComb[i] 
		     loopt:comblist[i].loopt sRate:SR revTime:comblist[i].rvt];
		if(comblist[i].rvt < 0.) [myComb[i] gain:-comblist[i].rvt];			}
	for(i=0; i<nAllpasses; i++) {
		myAllpass[i] = [Allpass create];
		[myAllpass[i] loopt:allpasslist[i].loopt sRate:SR revTime:allpasslist[i].rvt];
		if(allpasslist[i].rvt < 0.) [myAllpass[i] gain:-allpasslist[i].rvt];
			}

	for(i=0; i<nsamps; i++) {
		if(!GETIN(xin,input)) break;
		
		for(out[0]=sig=0; j<nCombs; j++)			
			sig += [myComb[j] bang:xin[0]];
			
		if(!nCombs) sig = xin[0];
		
		for(j=0; j<nAllpasses; j++) 
			sig = [myAllpass[j] bang:sig];
			
		out[0] = sig;
		ADDOUT(out,output);
	}
	nsamps = p[3] * SR;
printf("%d %d\n",nCombs,nAllpasses);
	for(i=0; i<nsamps; i++) {
		for(out[0]=sig=0; j<nCombs; j++)			
			sig += [myComb[j] bang:0.];
		for(j=0; j<nAllpasses; j++) 
			sig = [myAllpass[j] bang:sig];
		out[0] = sig;
		ADDOUT(out,output);
		}
	endnote(output);
	for(i=0; i<nCombs; i++) [myComb[i] freeup]; 
	for(i=0; i<nAllpasses; i++) [myAllpass[i] freeup];
}

double combbank(p,n_args)
float *p;
{
	int i;
	for(i=0,nCombs=0; i<n_args; i +=2,nCombs++) {
		comblist[nCombs].loopt = 1./p[i];
		comblist[nCombs].rvt = p[i+1];
		}
	for(i=0; i<nCombs; i++) printf("%f  %f\n",comblist[i].loopt,comblist[i].rvt);
}
double allpassbank(p,n_args)
float *p;
{
	int i;
	for(i=0,nAllpasses=0; i<n_args; i +=2,nAllpasses++) {
		allpasslist[nAllpasses].loopt =  1./p[i];
		allpasslist[nAllpasses].rvt = p[i+1];
		}
	for(i=0; i<nAllpasses; i++) printf("%f  %f\n",allpasslist[i].loopt,allpasslist[i].rvt);
}

int NBYTES = 32768;

profile()
{  
	UG_INTRO("reverbit",reverbit); 
	UG_INTRO("combbank",combbank);
	UG_INTRO("allpassbank",allpassbank);
}
